unit Unit1;

{$MODE objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, opbitmap, lazbridge, opbitmapformats, opimglib,
  ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Label1: TLabel;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
  private
    { private declarations }
    procedure ShowStatus(opb: TCanvasOpBitmap; StepText: string);
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  weiter, abort, running: boolean;

implementation

{ TForm1 }

//Alles was in dieser Methode passiert ist nur fuer die Demo. Kann man komplett vergessen fuer Batch Conversion etc.
procedure TForm1.ShowStatus(opb: TCanvasOpBitmap; StepText: string);
var AlphaBmp: TCanvasOpBitmap;
  Bmp: TBitmap;
begin
  Label1.Caption := StepText;
  AlphaBmp := TCanvasOpBitmap.Create;
  AlphaBmp.Width := opb.Width;
  AlphaBmp.Height := opb.Height;
  AlphaBmp.Canvas.Brush.Color := $FAFAFA;
  AlphaBmp.Canvas.FillRect(Rect(0, 0, AlphaBmp.Width, AlphaBmp.Height));
  Opb.AlphaBlend := true;
  AlphaBmp.Canvas.Draw(0, 0, opb);
  AssignOpBitmapToBitmap(AlphaBmp, Image1.Picture.Bitmap);
  AlphaBmp.free;
  weiter := false;
  repeat
    Application.ProcessMessages;
  until weiter or abort;
  if abort then exit;
end;

procedure TForm1.Button1Click(Sender: TObject);
var op: TOPPicture;
begin
  if running then weiter := true else
  begin
    running := true;
    Button1.Caption := 'Weiter';
    op := TOPPicture.create;
    op.LoadFromFile('paint.png');
    ShowStatus(op.Bitmap, 'Das Original-Bild');
    op.Bitmap.Monochrome := true;
    op.Bitmap.Canvas.Resample(op.Bitmap.Width * 4, op.Bitmap.Height * 4);
    ShowStatus(op.Bitmap, 'Das Bild vergroessern um Pixeleffekte zu vermindern');
    ReplaceNotColor(op.Bitmap, clwhite, clblack, 80);
    ShowStatus(op.Bitmap, 'Verlaufsfarben mit Schwarz ersetzen');
    Op.Bitmap.PixelFormat := pf1bit;
    Op.Bitmap.PixelFormat := pf32bit;
    ShowStatus(op.Bitmap, 'Auf Schwarz-Weiss reduzieren');
    op.Bitmap.Canvas.Resample(op.Bitmap.Width div 4, op.Bitmap.Height div 4);
    ShowStatus(op.Bitmap, 'Das Bild wieder in die Originaldimension resamplen');
    WhiteToAlpha(op.bitmap);
    ShowStatus(op.Bitmap, 'Weisse Farben in Alpha umwandeln. Die Bildinformation sitzt nun nurmehr in den Alpha-Bytes');
    ReplaceColorRGB(Op.Bitmap, Point(op.Bitmap.Width div 2, op.Bitmap.Height div 2), 255, 150, 0, 2);
    ShowStatus(op.Bitmap, 'Das Bild in die gewuenschte Farbe bringen, Alpha bleibt davon unberuehrt');
    op.SaveToFile('paint1.png');
    running := false;
    Button1.Caption := 'Start';
    ShowStatus(op.Bitmap, 'Das Bild mit Alpha in ein PNG speichern. FERTIG!');
    op.free;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  abort := true;
end;


initialization
{$I unit1.lrs}

end.
